<template>
	<main class="col-sm-10 ml-sm-auto px-3 mt-3">
		<div v-html="purifiedMailContents"/>
		<transition name="fade" type="out-in">
			<div v-if="!mailContents && !busy">
				Select email to view.
			</div>
		</transition>
		<transition name="fade" type="out-in">
			<div v-if="busy">
				<b-skeleton animation="wave" width="85%"></b-skeleton>
				<b-skeleton animation="wave" width="55%"></b-skeleton>
				<b-skeleton animation="wave" width="70%"></b-skeleton>
			</div>
		</transition>
	</main>
</template>

<script>
import DOMPurify from 'dompurify';
import {errorJsonToToast,} from '@/utils';

export default {
	name: 'MailContentsView',
	data() {
		return {
			mailContents: '',
			busy: false,
		};
	},
	computed: {
		purifiedMailContents() {
			return DOMPurify.sanitize(this.mailContents, {USE_PROFILES: {html: true,},});
		},
	},
	methods: {
		loadEmailBody() {
			const emailId = this.$route.query.mailId;
			console.debug('Loading email', emailId);
			if (emailId === null || emailId === undefined) {
				this.mailContents = '';
				return;
			}

			this.busy = true;
			this.mailContents = '';

			this.$http.post('/message/', {pk: emailId,})
				.then(r => {
					this.busy = false;
					const data = r.data.data;
					console.debug('Successfully loaded body', data);
					this.mailContents = data;
				})
				.catch(e => {
					this.busy = false;
					console.error('Failed to load email body', e);
					this.$bvToast.toast(errorJsonToToast(this, e), {
						title: 'Failed to load email body',
						variant: 'danger',
					});
				});

		},
	},
	watch: {
		'$route.query.mailId'() {
			console.debug('MailId changed, reloading...');
			this.loadEmailBody();
		},
	},
	mounted() {
		this.loadEmailBody();
	},
};
</script>

<style scoped>

</style>
